<?php

namespace FM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\CategoriaManutService;
use FM\Traits\TResponse;

class CategoriaManutController
{
    use TResponse;
    protected $CategoriaManutService;

    public function __construct(CategoriaManutService $CategoriaManutService) {
        $this->CategoriaManutService = $CategoriaManutService;
    }

    public function rotaBase(DTO\Request $request, DTO\Response $response) {
        $method = $request->getMethod();
        $parametros = $request->getParameters();
        $categoria = '';

        if ($method== "POST") {
            $categoria = $this->CategoriaManutService->insertNovaCategoriaManutencao($parametros);
        } else if ($method == "GET") {
            $categoria = $this->CategoriaManutService->getInformacoesCategoriaManut();
        }

        $dtsVal = new DataSet('categorias', [$categoria]);
        $response->addDataSet($dtsVal);
    }

    public function getFuncionarioCategoriaManut(DTO\Request $request, DTO\Response $response) {

        $funcionarios = $this->CategoriaManutService->getFuncionarioCategoriaManut();
        $dtsVal = new DataSet('funcionarios', $funcionarios);
        $response->addDataSet($dtsVal);
    }

    public function getCategoriaManutencao(Request $request)
    {
        try {
            $data = $this->CategoriaManutService->getCategoriaManutencao();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
