create or replace TRIGGER LOG_GOP_OPERSEMCUSTOROP
AFTER INSERT
ON OPERSEMCUSTOROP FOR EACH ROW
DECLARE
  V_TIPO                VARCHAR2(1);
  V_DSREMOTEADDR        VARCHAR2(15);
  V_DSREMOTEHOST        VARCHAR2(15);
  V_DSSERVERRDM         VARCHAR2(100);
  V_DSSERVMETHOD        VARCHAR2(4000);
  V_DSREMOTEOPER        VARCHAR2(12);
  V_DESC                VARCHAR2(4000);
  V_CDFILLOGOPER        VARCHAR2(4);
  V_ITPESQ              VARCHAR2(40);
  V_NMOPERADOR          VARCHAR2(40);
  V_CDOPERADOR          VARCHAR2(12);
  V_NMFILIAL            VARCHAR2(100);
  V_NMTIPOOPER          VARCHAR2(100);
  V_UNIDADE             VARCHAR2(500);

BEGIN
/* IDTIPOOPER - '1' - Inclusao, '2' - Alteracao, '3' - Exclusao*/
   V_TIPO         := '0';
   V_DESC         := '';
   V_ITPESQ       := '';
   V_NMOPERADOR   := '';
   V_CDOPERADOR   := :NEW.CDOPERULTATU;
   V_CDFILLOGOPER := '';

   NMOPERADOR(V_CDOPERADOR, V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

    V_DSSERVERRDM := 'gop00100_parametros_resultado_operacional';

    IF INSERTING THEN

        V_TIPO   := '1';
        V_ITPESQ := TO_CHAR(:NEW.CDFILIAL) || '|' || TO_CHAR(:NEW.CDTIPOOPER);
        V_DESC   := 'Parametros para Resultado Operacional' || chr(10) || '-> Consumo -> Lancamento';       
        
        IF TO_CHAR(:NEW.CDFILIAL) = 'T' OR TO_CHAR(:NEW.CDFILIAL) =  'P' THEN
           V_UNIDADE := 'Unidade: Padrao' || chr(10);
        ELSE
           SELECT MAX(NMFILIAL) INTO V_NMFILIAL FROM FILIAL WHERE CDFILIAL = :NEW.CDFILIAL;
           V_UNIDADE := 'Unidade: '|| NVL(:NEW.CDFILIAL, ' ') || ' - ' || V_NMFILIAL || chr(10);
        END IF;        

        SELECT MAX(NMTIPOOPER) INTO V_NMTIPOOPER FROM TIPOOPERAC WHERE IDENTRSAIDOP = :NEW.IDENTRSAID AND CDTIPOOPER = :NEW.CDTIPOOPER;

        IF :NEW.IDENTRSAID = 'E' THEN
            V_DESC := V_DESC || '-> Entradas que nao participam CMV: '|| chr(10) || chr(10) || V_UNIDADE || 'Entrada: '|| :NEW.CDTIPOOPER || ' - ' || V_NMTIPOOPER;

        ELSIF :NEW.IDENTRSAID = 'S' THEN
            V_DESC := V_DESC || '-> Saidas que nao participam CMV: ' || chr(10) || chr(10) || V_UNIDADE || 'Saida: '|| :NEW.CDTIPOOPER || ' - ' || V_NMTIPOOPER;

        END IF;
    END IF;

    IF NOT V_DESC IS NULL THEN
      INSERT INTO LOGOPERAGES
        (NMTABELA,     DTOPERACAO,   NMRESPOPER,  IDTIPOOPER,   DSOPERACAO,  CDPESQITEM,
         DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
      VALUES
        ('OPERSEMCUSTOROP', SYSDATE, NVL(V_NMOPERADOR,' '), V_TIPO, V_DESC, V_ITPESQ, NVL(V_DSSERVERRDM, ' '), 
          NVL(V_DSREMOTEADDR, ' '), NVL(V_DSREMOTEHOST, ' '), NVL(V_DSSERVMETHOD, ' '), NVL(V_CDOPERADOR, ' '),
          NVL(V_CDFILLOGOPER, ' '));
    END IF;
END;